
//#define Vanilla_like_water // vanilla water texture along with shader water stuff


float getWaterHeightmap(vec2 posxz, float waveM, float waveZ, float iswater) { // water waves
	vec2 pos = posxz;
	float moving = clamp(iswater*2.-1.0,0.0,1.0);
	vec2 movement = vec2(-0.0133*frameTimeCounter*moving);
	float caustic = 0.0;
	float weightSum = 0.0;
	float radiance =  2.39996;
	mat2 rotationMatrix  = mat2(vec2(cos(radiance),  -sin(radiance)),  vec2(sin(radiance),  cos(radiance)));
	
	for (int i = 0; i < 4; i++){
		pos = rotationMatrix * pos;

		float small_wave = texture2D(noisetex, pos/32.0 + movement).b;
		
		caustic += small_wave;

		weightSum += i;
	}
	return caustic * weightSum / 300. ;
}

float getWaterHeightmap(vec2 posxz, float iswater) { // water refraction
	vec2 pos = posxz;
	float moving = clamp(iswater*2.-1.0,0.0,1.0);
	vec2 movement = vec2(-0.0133*frameTimeCounter*moving);
	float caustic = 0.0;
	float weightSum = 0.0;
	float radiance =  2.39996;
	mat2 rotationMatrix  = mat2(vec2(cos(radiance),  -sin(radiance)),  vec2(sin(radiance),  cos(radiance)));

	for (int i = 1; i < 3; i++){
		float small_wave = texture2D(noisetex, pos/32.0 + movement).b;
		pos = rotationMatrix * pos;

		caustic += small_wave;
		weightSum += sqrt(i);
	}
	return caustic / weightSum;
}


vec3 getWaveHeight(vec2 posxz, float iswater){

	vec2 coord = posxz;

		float deltaPos = 0.25;

		float waveZ = mix(20.0,0.25,iswater);
		float waveM = mix(0.0,4.0,iswater);

		float h0 = getWaterHeightmap(coord  , waveM, waveZ, iswater);
		float h1 = getWaterHeightmap(coord + vec2(deltaPos,0.0), waveM, waveZ, iswater);
		float h3 = getWaterHeightmap(coord + vec2(0.0,deltaPos), waveM, waveZ, iswater);


		float xDelta = (h1-h0)/deltaPos*2.;
		float yDelta = (h3-h0)/deltaPos*2.;

		vec3 wave = normalize(vec3(xDelta,yDelta,1.0-pow(abs(xDelta+yDelta),2.0)));

		return wave;
}
